SystemOrganization addCategory: #'HTML-Exporter-Tests'!
SystemOrganization addCategory: #'HTML-Exporter'!

Object subclass: #HTMLExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter'!

!HTMLExporter commentStamp: 'SauravBhattacharya 7/17/2012 09:40' prior: 0!
A HTMLExporter is a Smalltalk module for exporting a GenericSpreadsheet class into an HTML format.

Instance Variables
!

!HTMLExporter class methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/24/2012 03:39'!
exportExample
|ghtml as ws w1|

as:= GenericSpreadsheet new.
w1:= as worksheetWithIndex: 1.
w1 maxNumOfColumns:5.
w1 maxNumOfRows: 5.

as addNewWorksheetWithTitle: 'Worksheet-2' maxRows:3 maxColumns:3.
ws := as worksheetWithIndex: 2.

ws addNewCellWithRowIndex: 1 columnIndex: 1 withCellValue: 'first' .
ws addNewCellWithRowIndex: 1 columnIndex: 2 withCellValue: '1' .
ws addNewCellWithRowIndex: 1 columnIndex: 3 withCellValue: 'second' .
ws addNewCellWithRowIndex: 2 columnIndex: 1 withCellValue: '2' .
ws addNewCellWithRowIndex: 2 columnIndex: 2 withCellValue: (Date year: 2012 month: 7 day:24).
ws addNewCellWithRowIndex: 2 columnIndex: 3 withCellValue: '4' .
ws addNewCellWithRowIndex: 3 columnIndex: 1 withCellValue: 'fourth'.
ws addNewCellWithRowIndex: 3 columnIndex: 2 withCellValue: '3' .
ws addNewCellWithRowIndex: 3 columnIndex: 3 withCellValue: 'third' .

ghtml := HTMLExporter new.
ghtml generateHTMLAt:'C:\' filename:'a.html' spreadsheet: as.
! !

!HTMLExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/19/2012 04:01'!
generateHTMLAt: aPath filename: aName spreadsheet: aSpreadsheet
	| filePath |
	filePath := aPath,aName .
	FileDirectory deleteFilePath: filePath .
	self renderSpreadsheet: aSpreadsheet atPath: filePath .
	! !

!HTMLExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/19/2012 03:53'!
renderCell: aCell intoStream: stream
	stream nextPutAll: '<td>'.
	aCell = nil
		ifFalse: [stream nextPutAll: (aCell cellValue)asString.].
	stream nextPutAll: '</td>'.! !

!HTMLExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/24/2012 03:32'!
renderSpreadsheet: aSpreadsheet atPath: filePath

	| stream numOfWorksheets |
	stream := StandardFileStream fileNamed: filePath.
	stream nextPutAll: '<html>
	<title>
		HTML Export of Spreadsheet
	</title>
	<body>
		'.
	stream nextPutAll: '<b>'; nextPutAll: aSpreadsheet spreadsheetTitle; nextPutAll: '</b></br>'.
	stream nextPutAll:' '.
	1 to: aSpreadsheet numberOfWorksheets  do: [:currwb | 
		self renderWorksheet: (aSpreadsheet worksheetWithIndex: currwb) intoStream: stream .
	].
	stream nextPutAll: '
	</body>	
</html>'.
	
	stream cr.
	stream close.! !

!HTMLExporter methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 7/19/2012 03:53'!
renderWorksheet:aWorksheet intoStream: stream
		stream nextPutAll: '<b>'.
		stream nextPutAll: aWorksheet  worksheetTitle.
		stream nextPutAll: '</b>'.
		stream nextPutAll: '<table border="1">'.
		
		1 to:aWorksheet maxNumOfRows do: [:row |
			stream nextPutAll: '<tr>'.
			1 to:aWorksheet maxNumOfColumns do: [:col | 				
				self renderCell: (aWorksheet cellWithRowIndex:row columnIndex:col) intoStream: stream.				
			].
			stream nextPutAll: '</tr>'.
		].
		stream nextPutAll: '</table>'.! !

Object subclass: #HTMLTableGenerator
	instanceVariableNames: 'width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter'!

!HTMLTableGenerator commentStamp: 'SauravBhattacharya 7/17/2012 09:40' prior: 0!
Class intention
	Given width and height as parameters, generate an empty HTML table.

Class collaborations
	I usually do not work in isolation but with the help of Yuriy Mironenko, Carla Florencia

!

!HTMLTableGenerator methodsFor: 'as yet unclassified' stamp: 'SauravBhattacharya 5/20/2012 01:13'!
generateHTMLTableAt: aPath filename: aName
	"Generates an HTML table with instance width and height at the entered location with the entered filname"

	| stream filePath fileName countCol countRow |
	filePath := aPath,aName .
	stream := StandardFileStream fileNamed: filePath .
	stream  nextPutAll: '<html>
	<body>
	Hello Smalltalk!!
	<table border="1">'.
	countCol:=0.
	[countCol >= height] whileFalse: 
	
	[stream nextPutAll: '<tr>'. 
	countRow :=0.
	[countRow=width] whileFalse: 
	[stream nextPutAll: '<td>'. stream nextPutAll: 'cell'.  stream nextPutAll: '</td>'. countRow:=countRow+1.] .
	stream nextPutAll: '</tr>'.
	countCol := countCol+ 1.
	].
	stream nextPutAll: '</table>'.
	stream  cr.
	stream close.
	
	! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 22:47'!
height 
	"comment stating purpose of message"

	| temporary variable names |
	^ height.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 23:00'!
height: aHeight
	"comment stating purpose of message"

	| temporary variable names |
	height:= aHeight .! !

!HTMLTableGenerator methodsFor: 'initialize-release' stamp: 'SauravBhattacharya 5/17/2012 22:59'!
initialize 
	"comment stating purpose of message"

	| temporary variable names |
	super initialize.
	width:= 2.
	height:= 2.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/17/2012 22:47'!
width 
	"comment stating purpose of message"

	| temporary variable names |
	^ width.! !

!HTMLTableGenerator methodsFor: 'accessing' stamp: 'SauravBhattacharya 5/18/2012 17:39'!
width: aWidth
	"comment stating purpose of message"

	| temporary variable names |
	width:=aWidth .! !

TestCase subclass: #HTMLTableGeneratorTest
	instanceVariableNames: 't'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML-Exporter-Tests'!

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 14:45'!
setUp 
	"comment stating purpose of message"

	| temporary variable names |
	t := HTMLTableGenerator new.
	
	! !

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 14:48'!
testHeight
	"comment stating purpose of message"

	| temporary variable names temp |
	temp := 18.
	t height: temp.
	self assert: (t height  = temp ).! !

!HTMLTableGeneratorTest methodsFor: 'testing' stamp: 'SauravBhattacharya 5/18/2012 15:20'!
testWidth
	"comment stating purpose of message"

	| temp |
	temp := 18.
	t width: temp.
	self assert: (t width = temp ).! !
